 /*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : June 2009

 File          : Osc_1_ADI_SM.c

 Hardware      : Applicable to ADuC7038

 Description   : This routine puts the HP OSC to GPIO_5 and IBIASOUT to VTEMP
					This allows Seamus to test the pressure on HP oscillator.
		
*********************************************************************/

#include <ADuC7038.h>

#define PAUSE_SYNC  3
#define NO_SYNC_PULSES 3
#define DIR_MASTER 0 		// master sends request
#define DIR_SLAVE  1 		// slave sends request

#define ADCKEY0	(*(volatile unsigned long *)0xFFFF0568)
#define ADCTST1	(*(volatile unsigned long *)0xFFFF056C)
#define ADCKEY1	(*(volatile unsigned long *)0xFFFF0578)


unsigned short Slave_Address = 0;
unsigned short Register_Address = 0;
                           /* 500s */

// CLK EN bits in PLL Test
#define HCLK     	0x00        // HVLK bits - 10MHZ - depnds on CD
#define VCO_OUT  	0x01        // PLL / VCO ouput
//#define PHASE_DET	0x02        // phase Detector
#define HP_CLK     	0x03        // High Precision osc 128
#define LP_OSC   	0x04        // 3% Osc 	128
#define HV_OSC   	0x05        // 1% Osc	128
//#define BYPASS_PLL  0x06     	//  Ext Clock
#define LOCK     	0x07        // Lock bit



void My_FIQ_Function(void);

 void LIN_INIT(void );
void delay(int);

unsigned int  adc_status=0 , loop = 0;
unsigned long fifo_data = 0;
unsigned short InfoBit_bt = 0;
unsigned short BsdTxBuffer[22];
	unsigned int Any_status	= 0;
	int status = 0;

   unsigned long it1=1234, it2=4321;

int main()
{
	GPCON = 0x00300000;		// output ECLK - HPOSC
	FIQ = My_FIQ_Function; 	// Initialise Interrupt Routine	 for LIN
	FIQEN = 0x20;			// Enable LIN  IRQ
	
	LIN_INIT();

	POWKEY0 = 0x01;		 	// Put all peripherals, PLL and Core Asleep
	POWCON	 = 0x179;		// default value is 78	- 20MHz
	POWKEY1 = 0xF4;			// 
	it1 = it1*it2;			// Dummy cycle to ensure correct power down 
    delay(20000);
 
//  PLLKEY0 = 0x000000AA;
//	PLLCON = 0x00;          // Low power oscillator 			  
//	PLLCON = 0x01;        	// Intern 1% Oszillator  Precision 	  
//  PLLKEY1 = 0x00000055;
//	it1 = it1*it2;			// Dummy cycle to ensure correct power down

    PLLKEY3 = 0x6B;
//	PLLTST = 0x8000	| HCLK <<6;					// 10.24 MHZ
//	PLLTST = 0x8000	| VCO_OUT <<6;				// 20.48 MHZ
	PLLTST = 0x8000	| HP_CLK <<6;				// 128 KHz
//	PLLTST = 0x8000	| HV_OSC <<6;				// 128 KHz
// 	PLLTST = 0x8000	| LP_OSC <<6;				// 128 KHz	
//	PLLTST = 0x8000	| BYPASS_PLL <<6;			// 		
//	PLLTST = 0x8000	| LOCK <<6;					// bit is one ??
    PLLKEY4 = 0xA9;
	it1 = it1*it2;			// Dummy cycle to ensure correct power down

	Any_status = PLLSTA;	// check Lock
	do 
		{
		Any_status = PLLSTA;
		}
	while ((Any_status & 0x02) != 2);

  
	delay(20000000);

	while(1)
	{
	}    							// Infinite Loop
}

void My_FIQ_Function() 
{
	
	while (FEESTA & 0x04);	// wait for the FLASH Controllor to be free.

	FEEMOD = 0x08;
	FEEADR = 0xFFC3;
	FEEDAT = 0x3CFF;
	FEECON = 0x06; 		//Mass Erase command
	while (FEESTA & 0x04){} //Wait for command to finish

 	return ;
}

void delay (int length){
	while (length >=0)
    	length--;
}
 void LIN_INIT(void )
{
int  HVstatus;
	LINCON = 0x880;						// Enable LIN , checksum, BREAK=0 - enabled.
	do										
	{
		HVDAT = 0x00; 						// Enable Normal LIN TX mode / reenable short circuit
		HVCON = 0x08; 						// Write to Config
		do
		{
			HVstatus = HVCON;
		}
		while(HVstatus & 0x1); 				//  command finished
	}
	while (!(HVstatus & 0x4));				// transmit command 

// LINWU = 0x0010;							// Wake Up with INWU also
// LINBK = 0x070;						// Set number of 128kHz periods to generate a Break Interrupt
//LINBK = 0x7700;							// 0x46 / 128kHz ~ 492us which is just over 11 TBits.
											// According to LIN V2.0, a slave with a clock accuracy of <2% may
											// use a break detection of 9.5 bit, otherwise a break detection of
											// 11 bits is required
											// This is for 19200bps
}
